var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../di/DITransient", "./TransientDisposable", "./types"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var DITransient_1 = require("../di/DITransient");
    var TransientDisposable_1 = require("./TransientDisposable");
    var types_1 = require("./types");
    /**
     * We recommend using CancelTokenFactory instead of using CancelToken directly.
     * This class will cancel previous token before creating new token for given key.
     */
    var CancelTokenFactory = /** @class */ (function (_super) {
        __extends(CancelTokenFactory, _super);
        function CancelTokenFactory() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.mToken = {};
            return _this;
        }
        /**
         * This will create a new token and cancel previous token
         */
        CancelTokenFactory.prototype.newToken = function (key, timeout) {
            if (timeout === void 0) { timeout = -1; }
            key = key || "__old";
            var old = this.mToken[key];
            if (old) {
                old.cancel();
            }
            var n = this.mToken[key] = new types_1.CancelToken(timeout);
            return n;
        };
        CancelTokenFactory.prototype.dispose = function () {
            for (var key in this.mToken) {
                if (this.mToken.hasOwnProperty(key)) {
                    var element = this.mToken[key];
                    element.dispose();
                }
            }
        };
        CancelTokenFactory = __decorate([
            DITransient_1.default()
        ], CancelTokenFactory);
        return CancelTokenFactory;
    }(TransientDisposable_1.default));
    exports.default = CancelTokenFactory;
});
//# sourceMappingURL=CancelTokenFactory.js.map